=== src/iff.imageio/CMakeLists.txt ===
add_oiio_plugin (iffinput.cpp iffoutput.cpp iff_pvt.cpp)
