=== debian/changelog ===
openimageio (1.3.12~dfsg0-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - 0099-as-needed-fix.patch: Move -latomic to the right part of the link
      line to resolve FTBFS with as-needed on -latomic arches like powerpc.
    - 0099-libOpenImageIO-underlinked.patch: Link libOpenImageIO with -ldl.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 07 Feb 2014 18:54:12 -0700

openimageio (1.3.12~dfsg0-1) unstable; urgency=medium

  * New upstream release
    - debian/patches/: patchset updated
      - 0005-Fix_FTBFS_due_to_OpenEXR.patch dropped
        (applied upstream)
  * debian/copyright: license issue fixed (Closes: #737986)
  * debian/watch: exclude dev releases

 -- Matteo F. Vescovi <mfvescovi@gmail.com>  Fri, 07 Feb 2014 16:07:26 +0100

openimageio (1.3.11~dfsg0-1) unstable; urgency=low

  * New upstream release
    - debian/patches/: patchset refreshed against v1.3.11
      - 0002-Fix_IlmBase_issue.patch refreshed
      - 0005-Fix_FTBFS_due_to_OpenEXR.patch added
    - debian/rules: --sourcedirectory parameter dropped
  * debian/control: Uploader e-mail address updated
  * debian/control: S-V bump 3.9.4 => 3.9.5 (no changes needed)
  * debian/control: OpenColorIO support enabled (Closes: #721001)
  * debian/: SONAME bump 1.2 => 1.3
    - control: "libopenimageio1.2" => "libopenimageio1.3"
    - libopenimageio1.2.install => libopenimageio1.3.install

 -- Matteo F. Vescovi <mfvescovi@gmail.com>  Thu, 23 Jan 2014 09:27:38 +0100

openimageio (1.2.3~dfsg0-1ubuntu2) trusty; urgency=medium

  * No change rebuild against glew 1.10.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 Jan 2014 13:23:11 +0000

openimageio (1.2.3~dfsg0-1ubuntu1) trusty; urgency=medium

  * 0099-as-needed-fix.patch: Move -latomic to the right part of the link
    line to resolve FTBFS with as-needed on -latomic arches like powerpc.
  * 0099-libOpenImageIO-underlinked.patch: Link libOpenImageIO with -ldl.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 19 Dec 2013 19:06:30 -0700

openimageio (1.2.3~dfsg0-1) unstable; urgency=low

  * New upstream release

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Tue, 05 Nov 2013 09:36:03 +0100

openimageio (1.2.2~dfsg0-1) unstable; urgency=low

  * New upstream release
    - debian/patches/: patchset updated
      - 0005-Fix_compiler_error_on_mips.patch dropped
        (applied upstream)

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Thu, 03 Oct 2013 16:17:55 +0200

openimageio (1.2.1~dfsg0-3) unstable; urgency=low

  * debian/patches/: patchset updated
    - 0005-Fix_compiler_error_on_mips.patch added

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Wed, 14 Aug 2013 12:16:34 +0200

openimageio (1.2.1~dfsg0-2) unstable; urgency=low

  * Upload to unstable
  * debian/manpages/: manpages updated (Closes: #719264)

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Mon, 12 Aug 2013 10:01:05 +0200

openimageio (1.2.1~dfsg0-1) experimental; urgency=low

  * New upstream release
    - debian/patches/: patchset updated
      - 0001-Fix_docs_generation.patch refreshed
      - 0005-Fix_FTBFS_due_to_bit_range_convert_issue.patch dropped
        since applied upstream

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Wed, 07 Aug 2013 10:01:24 +0200

openimageio (1.2.0~dfsg0-2) experimental; urgency=low

  * debian/patches/: patchset updated
    - 0005-Fix_FTBFS_due_to_bit_range_convert_issue.patch added
      Thanks to Larry Gritz (upstream devel) for the hint.

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Tue, 16 Jul 2013 17:16:16 +0200

openimageio (1.2.0~dfsg0-1) experimental; urgency=low

  * New upstream release

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Wed, 10 Jul 2013 10:18:29 +0200

openimageio (1.2.0~beta2~dfsg0-1) experimental; urgency=low

  * New upstream beta release

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Fri, 05 Jul 2013 11:58:46 +0200

openimageio (1.2.0~beta1~dfsg0-1) experimental; urgency=low

  * New upstream beta release
    - debian/: SONAME bump 1.1 => 1.2
    - debian/patches/: patchset updated
      - 0004-Fix_pause_issue.patch dropped (applied upstream)
      - 0005-Fix_FTBFS_on_atomic_operations.patch renamed to #0004

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Fri, 28 Jun 2013 10:17:26 +0200
